/*
*  Programma gestione inventario
*
*/

#include "l3w_include.ch"

FUNCTION main( ... )
LOCAL aArgsIn := hb_AParams()
IF l3w_fSetsys( aArgsIn )
   p000_main()
ENDIF
RETURN NIL

/*
*        funzione principale
* dimensione finestre
* 1024x768, 1020x765, 996x747, 992x744, 988x741, 980x735, 940x705, 900x675
* 860x645, 820x615, 780x585, 750x555, 700x525, 660x495, 620x465, 580x435, 540x405
*/
STATIC FUNCTION p000_main()
p000_procname := "gemap000"
p000_proctitl := "Men principale"

l3w_fSetaini("Application","Appname","gemap000")
l3w_fSetaini("Application","Apptitle","Gestione Mailing")
l3w_fSetaini("Application","Appver","v. 0.0.0")

aTipologie := {}
AADD( aTipologie, {"AGE_00001",  "AGENZIE"} )
AADD( aTipologie, {"CANO_00001", "CANOA"} )
AADD( aTipologie, {"CONV_00001", "GENERICA"} )
AADD( aTipologie, {"CORR_00001", "GENERICA"} )
AADD( aTipologie, {"EXPE_00001", "GENERICA"} )
AADD( aTipologie, {"FIRA_00001", "FIRAFT"} )
AADD( aTipologie, {"FIRA_00002", "FIRAFT"} )
AADD( aTipologie, {"FIRA_00003", "FIRAFT"} )
AADD( aTipologie, {"FIRA_00004", "FIRAFT"} )
AADD( aTipologie, {"GROU_00001", "GENERICA"} )
AADD( aTipologie, {"MSPO_00001", "GENERICA"} )
AADD( aTipologie, {"MSPO_00002", "GENERICA"} )
AADD( aTipologie, {"OLDR_00001", "GENERICA"} )
AADD( aTipologie, {"OUTD_00001", "OUTDOOR"} )
AADD( aTipologie, {"OUTD_00002", "OUTDOOR"} )
AADD( aTipologie, {"RAFT_00001", "GENERICA"} )
AADD( aTipologie, {"RAFT_00002", "GENERICA"} )
AADD( aTipologie, {"RAFT_00003", "GENERICA"} )
AADD( aTipologie, {"SAFE_00001", "SAFE"} )
AADD( aTipologie, {"UNDEFINED1", "GENERICA"} )
AADD( aTipologie, {"YOGA_00001", "YOGA"} )

aNuovetipo := {}
AADD( aNuovetipo, {"AGENZIE",  "Agenzie"} )
AADD( aNuovetipo, {"CANOA",    "Canoa"} )
AADD( aNuovetipo, {"GENERICA", "Categoria generica"} )
AADD( aNuovetipo, {"FIRAFT" ,  "Firaft"} )
AADD( aNuovetipo, {"OUTDOOR",  "Outdoor Team Building"} )
AADD( aNuovetipo, {"SAFE",     "Salvamento Fluviale"} )
AADD( aNuovetipo, {"YOGA",     "Yoga"} )

cTipcode := "UNDEF"
cTipdesc := "UNDEF"

aMailing := {}
AADD( aMailing, {"001",  "001" , "Auguri"} )
AADD( aMailing, {"002",  "002" , "Rafting"} )
AADD( aMailing, {"003",  "003" , "Salvamento Fluviale"} )
AADD( aMailing, {"004",  "101" , "Multisport"} )
AADD( aMailing, {"",     "005" , "Outdoor"} )
AADD( aMailing, {"999",  "004" , "Yoga"} )

p000_windefine()

RETURN NIL

/*
* window define
*/
STATIC FUNCTION p000_windefine()

SET NAVIGATION EXTENDED
DEFINE WINDOW p000win ;
  AT 0,0 ;
  WIDTH 980 ;
  HEIGHT 735 ;
  TITLE l3w_fGetaini("Apptitle") + " (" + l3w_fGetaini("Appver") + ") :: " +p000_proctitl + " (" + p000_procname + ")" ;
  NOTIFYICON 'L3W_L3WICO' ;
  ICON 'L3W_L3WICO' ;
  MAIN ;
  NOMAXIMIZE ;
  NOSIZE ;
  ON INIT p000_login() ;
  ON RELEASE p000_release() ;
  FONT l3w_fGetaini("fontmaskc") ;
  SIZE VAL(l3w_fGetaini("fontmaskn"))

  DEFINE MAIN MENU
    DEFINE POPUP '&File'
      MENUITEM 'e&Xit' ACTION p000_exit()
    END POPUP
    DEFINE POPUP '&Trascodifica'
      MENUITEM '&1 Ragione sociale' ACTION p001_A()
      MENUITEM '&2 Liste'           ACTION p002_A()
      MENUITEM '&3 Lingue'          ACTION p003_A()
      MENUITEM '&4 Tipologie'       ACTION p004_A()
      MENUITEM '&6 Iscritti'        ACTION p006_A()
    END POPUP
  END MENU

  DEFINE STATUSBAR
    STATUSITEM "DbName :" WIDTH 250
    STATUSITEM "User :" WIDTH 250
    CLOCK  WIDTH 80
    DATE  WIDTH 100
  END STATUSBAR

 DEFINE LABEL lb_counter
  ROW 60
  COL 20
  VALUE ''
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL

  DEFINE LABEL lb_delete
  ROW 120
  COL 20
  VALUE ''
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL

END WINDOW
CENTER WINDOW p000win
p000_init()
ACTIVATE WINDOW p000win
RETURN NIL

/*
* init maschera
*/
STATIC FUNCTION p000_init()
RETURN NIL

/*
* release maschera
*/
STATIC FUNCTION p000_release()
DBUNLOCKALL()
DBCLOSEALL()
RETURN NIL

/*
* premuto uscita
*/
STATIC FUNCTION p000_exit()
p000win.release
RETURN NIL

STATIC FUNCTION p000_login()
LOCAL lRet := l3w_fLogin()
IF lRet==.T. .AND. l3w_fGetperms(p000_procname, "x")==.T. .AND. p000_opendb()==.T.
  p000_status()
ELSE
  p000win.release
ENDIF
RETURN NIL

/*
*	aggiorna campi status bar
*/
STATIC FUNCTION p000_status()
p000win.StatusBar.Item(1) :=  "DataBase : " + l3w_fGetardb("Dbcurds")
p000win.StatusBar.Item(2) :=  "User : " + l3w_fGetaini("Usrname")
RETURN NIL

/*
*	who am i
*/
STATIC FUNCTION p000_whoami()
MSGSTOP(PADL("UserName :: " + l3w_fnetinfo("UserName"), 90) + HB_OSNEWLINE() + ;
        PADL("HostName :: " + l3w_fnetinfo("HostName"), 90) + HB_OSNEWLINE() + ;
        PADL("Domain   :: " + l3w_fnetinfo("Domain"), 90) )
RETURN NIL

/*
*	apertura database
*/
STATIC FUNCTION p000_opendb()
LOCAL lOpendb := .F.
IF l3w_fNetuse("progress","progress",{"progres1","progres2"},"S", NIL) == .T. .AND. ;
   l3w_fNetuse("ragsocaz","ragsocaz",{"ragsoca1"},"S", NIL) == .T. .AND. ;
   l3w_fNetuse("tmailing","tmailing",{"tmailin1","tmailin2"},"S", NIL) == .T. .AND. ;
   l3w_fNetuse("tlanguag","tlanguag",{"tlangua1","tlangua2"},"S", NIL) == .T. .AND. ;
   l3w_fNetuse("tcontact","tcontact",{"tcontac1","tcontac2"},"S", NIL) == .T. .AND. ;
   l3w_fNetuse("contmlls","contmlls",{"contmll1","contmll2"},"S", NIL) == .T. .AND. ;
   l3w_fNetuse("conttest","conttest",{"conttes1","conttes2","conttes3"},"S", NIL) == .T.
 lOpendb := .T.
ENDIF
RETURN lOpendb

/*
* trascodifica ragsocaz : verifiche
*/
STATIC FUNCTION p001_A()
LOCAL cLocal := l3w_fGetaini("Path","Application") + SPACE(60)
LOCAL cPath := InputBox ('Cartella','Enter path',cLocal)
LOCAL cFilename := "ragsocaz", cFile := ""
IF l3w_fIspath(@cPath)
 cFile := l3w_fAddpath(cPath, cFilename, ".dbf")
 IF FILE(cFile)
  IF l3w_fNetuse( "ragsocaz", "olddbf", NIL, "S", cPath) == .T.
   IF MSGYESNO("Confermi importazione ?")
    p001_B()
   ENDIF
   olddbf->(DBCLOSEAREA())
  ELSE
   MSGSTOP("Impossibile aprire" + cFile)
  ENDIF
 ELSE
  MSGSTOP("Non esiste" + HB_OSNEWLINE() + cFile )
 ENDIF
ELSE
 MSGSTOP("Path errata")
ENDIF
RETURN NIL
/*
* trascodifica ragsocaz : esegue
*/
STATIC FUNCTION p001_B()
LOCAL nRecord := 0, nRecadd := 0, nRecupd := 0
olddbf->(DBGOTOP())
DO WHILE !olddbf->(EOF())
 nRecord += 1
 IF l3w_fAddrec("ragsocaz") == .T.
  ragsocaz->adminproc := "trasco01"
  ragsocaz->adminuser := l3w_fGetaini("usrlogin")
  ragsocaz->admintstp := HB_TTOS( HB_DATETIME() )
  ragsocaz->azncodice := "0" + olddbf->azcodicei
  ragsocaz->aznragsoc := olddbf->azragsoci
  ragsocaz->aznsedleg := olddbf->azlegindi
  ragsocaz->aznpariva := olddbf->azpartiva
  ragsocaz->azncodfis := olddbf->azcodfisc
  ragsocaz->aznsedope := olddbf->azopeindi
  ragsocaz->aznfaxnum := olddbf->aztelfix1
  ragsocaz->aznfixnum := olddbf->azfaxfix1
  ragsocaz->azncelnum := olddbf->aztelcel1
  ragsocaz->aznwebhtt := "http://www.TotemAdventure.com"
  ragsocaz->aznmailin := olddbf->azeminfor
  ragsocaz->(DBCOMMIT())
  nRecadd += 1
 ELSE
  MSGSTOP("Impossibile aggiungere" + HB_OSNEWLINE() + "0" + olddbf->azcodicei)
 ENDIF
 olddbf->(DBSKIP(+1))
ENDDO
MSGSTOP("Finito" + HB_OSNEWLINE() + "Record Letti "+ STR(nRecord) + HB_OSNEWLINE() + "Record Aggiunti "+ STR(nRecadd) + HB_OSNEWLINE() + "Record Update "+ STR(nRecupd))
RETURN NIL

/*
* trascodifica tmailing : verifiche
*/
STATIC FUNCTION p002_A()
IF MSGYESNO("Confermi ?")
 p002_B()
ENDIF
RETURN NIL
/*
* trascodifica tmailing : esegue
*/
STATIC FUNCTION p002_B()
LOCAL nRecord := 0, nRecadd := 0, nRecupd := 0
LOCAL nX := 0
FOR nX := 1 TO LEN(aMailing)
 nRecord += 1
 IF l3w_fAddrec("tmailing") == .T.
  tmailing->adminproc := "trasco01"
  tmailing->adminuser := l3w_fGetaini("usrlogin")
  tmailing->admintstp := HB_TTOS( HB_DATETIME() )
  tmailing->tmailcode := aMailing[nX,2]
  tmailing->tmaildesc := aMailing[nX,3]
  tmailing->(DBCOMMIT())
  nRecadd += 1
 ELSE
  MSGSTOP("Impossibile aggiungere" + HB_OSNEWLINE() + aMailing[nX,2])
 ENDIF
NEXT nX
MSGSTOP("Finito" + HB_OSNEWLINE() + "Record Letti "+ STR(nRecord) + HB_OSNEWLINE() + "Record Aggiunti "+ STR(nRecadd) + HB_OSNEWLINE() + "Record Update "+ STR(nRecupd))
RETURN NIL

/*
* trascodifica tlanguag : verifiche
*/
STATIC FUNCTION p003_A()
LOCAL cLocal := l3w_fGetaini("Path","Application") + SPACE(60)
LOCAL cPath := InputBox ('Cartella','Enter path',cLocal)
LOCAL cFilename := "tlanguag", cFile := ""
IF l3w_fIspath(@cPath)
 cFile := l3w_fAddpath(cPath, cFilename, ".dbf")
 IF FILE(cFile)
  IF l3w_fNetuse( "tlanguag", "olddbf", NIL, "S", cPath) == .T.
   IF MSGYESNO("Confermi importazione ?")
    p003_B()
   ENDIF
   olddbf->(DBCLOSEAREA())
  ELSE
   MSGSTOP("Impossibile aprire" + cFile)
  ENDIF
 ELSE
  MSGSTOP("Non esiste" + HB_OSNEWLINE() + cFile )
 ENDIF
ELSE
 MSGSTOP("Path errata")
ENDIF
RETURN NIL
/*
* trascodifica tlanguag : esegue
*/
STATIC FUNCTION p003_B()
LOCAL nRecord := 0, nRecadd := 0, nRecupd := 0
LOCAL nX := 0
olddbf->(DBGOTOP())
DO WHILE !olddbf->(EOF())
 nRecord += 1
 IF l3w_fAddrec("tlanguag") == .T.
  tlanguag->adminproc := "trasco01"
  tlanguag->adminuser := l3w_fGetaini("usrlogin")
  tlanguag->admintstp := HB_TTOS( HB_DATETIME() )
  tlanguag->tlangcode := olddbf->tlangcode
  tlanguag->tlangdesc := olddbf->tlangdesc
  tlanguag->(DBCOMMIT())
  nRecadd += 1
 ELSE
  MSGSTOP("Impossibile aggiungere" + HB_OSNEWLINE() + "0" + olddbf->tlangcode)
 ENDIF
 olddbf->(DBSKIP(+1))
ENDDO
MSGSTOP("Finito" + HB_OSNEWLINE() + "Record Letti "+ STR(nRecord) + HB_OSNEWLINE() + "Record Aggiunti "+ STR(nRecadd) + HB_OSNEWLINE() + "Record Update "+ STR(nRecupd))
RETURN NIL

/*
* trascodifica tcontact : verifiche
*/
STATIC FUNCTION p004_A()
IF MSGYESNO("Confermi ?")
 p004_B()
ENDIF
RETURN NIL
/*
* trascodifica tcontact : esegue
*/
STATIC FUNCTION p004_B()
LOCAL nRecord := 0, nRecadd := 0, nRecupd := 0
LOCAL nX := 0
FOR nX := 1 TO LEN(aNuovetipo)
 nRecord += 1
 IF l3w_fAddrec("tcontact") == .T.
  tcontact->adminproc := "trasco01"
  tcontact->adminuser := l3w_fGetaini("usrlogin")
  tcontact->admintstp := HB_TTOS( HB_DATETIME() )
  tcontact->tcontcode := aNuovetipo[nX,1]
  tcontact->tcontdesc := aNuovetipo[nX,2]
  tcontact->(DBCOMMIT())
  nRecadd += 1
 ELSE
  MSGSTOP("Impossibile aggiungere" + HB_OSNEWLINE() + aNuovetipo[nX,1])
 ENDIF
NEXT nX
MSGSTOP("Finito" + HB_OSNEWLINE() + "Record Letti "+ STR(nRecord) + HB_OSNEWLINE() + "Record Aggiunti "+ STR(nRecadd) + HB_OSNEWLINE() + "Record Update "+ STR(nRecupd))
RETURN NIL
/*
* trascodifica conttest : verifiche
*/
STATIC FUNCTION p006_A()
LOCAL cLocal := l3w_fGetaini("Path","Application") + SPACE(60)
LOCAL cPath := InputBox ('Cartella','Enter path',cLocal)
LOCAL cFiletesta := "contacts", cTesta := ""
IF l3w_fIspath(@cPath)
 cTesta := l3w_fAddpath(cPath, cFiletesta, ".dbf")
 IF FILE(cTesta)
  IF l3w_fNetuse( "contacts", "testata", NIL, "S", cPath) == .T.
   IF MSGYESNO("Confermi importazione ?")
    p006_B()
   ENDIF
   testata->(DBCLOSEAREA())
  ELSE
   MSGSTOP("Impossibile aprire" + cTesta + HB_OSNEWLINE() )
  ENDIF
 ELSE
  MSGSTOP("Non esiste" + HB_OSNEWLINE() + cTesta + HB_OSNEWLINE() )
 ENDIF
ELSE
 MSGSTOP("Path errata")
ENDIF
RETURN NIL
/*
* trascodifica conttest : esegue
*/
STATIC FUNCTION p006_B()
LOCAL nCounter := 0, cStatus := "", nMaxcode := 0, aNome := {}, nX := 0, lAlmenouno := .F., nDelete := 0, aMlls := {}, nF := 0, nNx := 0
* reperisce contatore
cProg := SUBSTR("ULTCONTA"+SPACE(8),1 , 8)
progress->(ORDSETFOCUS(1))
IF progress->(DBSEEK(cProg, .F.))
 IF l3w_fReclock("progress") == .T.
  nCounter := 0
* inizio scansione testata
  testata->(DBGOTOP())
  DO WHILE !testata->(EOF())
    nCounter += 1
    p000win.lb_counter.Value := STRZERO( nCounter, 8, 0)
    p000win.lb_counter.Refresh()
    lAlmenouno := .F.
* scarto cancellati
*  IF testata->(DELETE()) .OR. testata->mdcdelflg=="S" .OR. LEN(ALLTRIM(DTOS(testata->mdcdelete))) <> 0
*   nDelete += 1
*   p000win.lb_delete.Value := STRZERO( nDelete, 8, 0)
*   p000win.lb_delete.Refresh()
*  ELSE
* appende testata
   IF l3w_fAddrec("conttest") == .T.
    nMaxcode := MAX( nMaxcode, VAL(testata->mdccodice) )
    conttest->adminproc := "trasco01"
    conttest->adminuser := l3w_fGetaini("usrlogin")
    conttest->admintstp := HB_TTOS( HB_DATETIME() )
    conttest->pdccodice := testata->mdccodice
    cStatus := "A"
    IF testata->(DELETE()) .OR. testata->mdcdelflg=="S" .OR. LEN(ALLTRIM(DTOS(testata->mdcdelete))) <> 0
     cStatus := "D"
    ENDIF
    conttest->pdcstatus := cStatus
    aNome := HB_RegexSplit( " ", testata->mdcperdco, 2 )
    conttest->pdccognom := ALLTRIM(aNome[1])
    conttest->pdcnomepe := ALLTRIM(aNome[2])
    conttest->pdcazidco := ALLTRIM(testata->mdcazidco)
    conttest->pdcindiri := ALLTRIM(testata->mdcindiri)
    conttest->pdcnazcit := ALLTRIM(testata->mdcnazcit)
    nX := ASCAN( aTipologie, {|x| x[1]==ALLTRIM(testata->mdctipdco)})
    conttest->pdctipdco := aTipologie[nX,2]
    conttest->pdclangue := ALLTRIM(testata->mdclangue)
    conttest->pdcmailad := ALLTRIM(testata->mdcaddres) + "@" + ALLTRIM(testata->mdcdomain)
    conttest->pdciscrit := DTOS(testata->mdciscrit)
    conttest->pdcdelete := DTOS(testata->mdcdelete)
    IF cStatus == "D" .AND. LEN(ALLTRIM(DTOS(testata->mdcdelete))) == 0
     conttest->pdcdelete := DTOS(DATE())
    ENDIF
    conttest->pdcdelwhy := ALLTRIM(testata->mdcdelwhy)
    conttest->(DBCOMMIT())
* questa routine unifica i codici
    aMlls := p006_D()
    lAlmenouno := .F.
    FOR nF := 1 TO LEN( aMlls )
     lAlmenouno := IIF( p006_C(testata->mdccodice, cStatus, aMlls[nF])==.T., .T., lAlmenouno)
    NEXT nF
    IF lAlmenouno == .F.
     lAlmenouno := p006_C(testata->mdccodice, cStatus, "001")
    ENDIF
* Aggiunge, se inesistente, il codice 001
   nNx := ASCAN(aMlls, "001")
   IF nNx==0
    p006_C(testata->mdccodice, cStatus, "001")
   ENDIF
   ELSE
    MSGSTOP("Impossibile appendere testata per "+testata->mdccodice)
   ENDIF
* scarto cancellati
*  ENDIF
   testata->(DBSKIP(+1))
  ENDDO
*aggiorna contatore
  progress->adminproc := "trasco01"
  progress->adminuser := l3w_fGetaini("usrlogin")
  progress->admintstp := HB_TTOS( HB_DATETIME() )
  progress->prgnumero := nMaxcode
  progress->(DBCOMMIT())
  progress->(DBUNLOCK())
 ELSE
  MSGSTOP("Progressivo bloccato")
 ENDIF
ELSE
 MSGSTOP("Manca progressivo")
ENDIF

MSGSTOP("Finito")
RETURN NIL
/*
* trascodifica conttest : esegue
*/
STATIC FUNCTION p006_C(cPdccode, cPdcst, cMllist)
LOCAL lReturn := .F.
* aggiorna dati mailing list
IF l3w_fAddrec("contmlls") == .T.
 lReturn := .T.
 contmlls->adminproc := "trasco01"
 contmlls->adminuser := l3w_fGetaini("usrlogin")
 contmlls->admintstp := HB_TTOS( HB_DATETIME() )
 contmlls->mllcodice := cPdccode
 contmlls->mllcodeml := cMllist
 contmlls->mllstatus := cPdcst
 contmlls->(DBCOMMIT())
ELSE
 MSGSTOP("Impossibile appendere mailing list per "+cPdccode)
ENDIF
RETURN lReturn
/*
* trascodifica conttest : esegue
*/
STATIC FUNCTION p006_D()
LOCAL nY := 0, nX := 0, aReturn := {}
IF LEN( ALLTRIM( testata->mdcmail01 ) ) <> 0
 nY := ASCAN( aMailing, {|x| x[1]==ALLTRIM( testata->mdcmail01 )})
 IF nY <> 0
  nX := ASCAN( aReturn, aMailing[nY,2] )
  IF nX == 0
   AADD( aReturn, aMailing[nY,2] )
  ENDIF
 ENDIF
ENDIF
IF LEN( ALLTRIM( testata->mdcmail02 ) ) <> 0
 nY := ASCAN( aMailing, {|x| x[1]==ALLTRIM( testata->mdcmail02 )})
 IF nY <> 0
  nX := ASCAN( aReturn, aMailing[nY,2] )
  IF nX == 0
   AADD( aReturn, aMailing[nY,2] )
  ENDIF
 ENDIF
ENDIF
IF LEN( ALLTRIM( testata->mdcmail03 ) ) <> 0
 nY := ASCAN( aMailing, {|x| x[1]==ALLTRIM( testata->mdcmail03 )})
 IF nY <> 0
  nX := ASCAN( aReturn, aMailing[nY,2] )
  IF nX == 0
   AADD( aReturn, aMailing[nY,2] )
  ENDIF
 ENDIF
ENDIF
IF LEN( ALLTRIM( testata->mdcmail04 ) ) <> 0
 nY := ASCAN( aMailing, {|x| x[1]==ALLTRIM( testata->mdcmail04 )})
 IF nY <> 0
  nX := ASCAN( aReturn, aMailing[nY,2] )
  IF nX == 0
   AADD( aReturn, aMailing[nY,2] )
  ENDIF
 ENDIF
ENDIF
IF LEN( ALLTRIM( testata->mdcmail05 ) ) <> 0
 nY := ASCAN( aMailing, {|x| x[1]==ALLTRIM( testata->mdcmail05 )})
 IF nY <> 0
  nX := ASCAN( aReturn, aMailing[nY,2] )
  IF nX == 0
   AADD( aReturn, aMailing[nY,2] )
  ENDIF
 ENDIF
ENDIF
IF LEN( ALLTRIM( testata->mdcmail06 ) ) <> 0
 nY := ASCAN( aMailing, {|x| x[1]==ALLTRIM( testata->mdcmail06 )})
 IF nY <> 0
  nX := ASCAN( aReturn, aMailing[nY,2] )
  IF nX == 0
   AADD( aReturn, aMailing[nY,2] )
  ENDIF
 ENDIF
ENDIF
IF LEN( ALLTRIM( testata->mdcmail07 ) ) <> 0
 nY := ASCAN( aMailing, {|x| x[1]==ALLTRIM( testata->mdcmail07 )})
 IF nY <> 0
  nX := ASCAN( aReturn, aMailing[nY,2] )
  IF nX == 0
   AADD( aReturn, aMailing[nY,2] )
  ENDIF
 ENDIF
ENDIF
IF LEN( ALLTRIM( testata->mdcmail08 ) ) <> 0
 nY := ASCAN( aMailing, {|x| x[1]==ALLTRIM( testata->mdcmail08 )})
 IF nY <> 0
  nX := ASCAN( aReturn, aMailing[nY,2] )
  IF nX == 0
   AADD( aReturn, aMailing[nY,2] )
  ENDIF
 ENDIF
ENDIF
IF LEN( ALLTRIM( testata->mdcmail09 ) ) <> 0
 nY := ASCAN( aMailing, {|x| x[1]==ALLTRIM( testata->mdcmail09 )})
 IF nY <> 0
  nX := ASCAN( aReturn, aMailing[nY,2] )
  IF nX == 0
   AADD( aReturn, aMailing[nY,2] )
  ENDIF
 ENDIF
ENDIF
IF LEN( ALLTRIM( testata->mdcmail10 ) ) <> 0
 nY := ASCAN( aMailing, {|x| x[1]==ALLTRIM( testata->mdcmail10 )})
 IF nY <> 0
  nX := ASCAN( aReturn, aMailing[nY,2] )
  IF nX == 0
   AADD( aReturn, aMailing[nY,2] )
  ENDIF
 ENDIF
ENDIF
RETURN aReturn